<apex:page controller="BoreholeProductionController" showHeader="false" extensions="BoreholeProductionXML" sidebar="false" tabStyle="GRD_Borehole__c">
<style>
.isloading-overlay {
  position:relative;
  text-align:center;
}
.isloading-overlay .isloading-wrapper {
  background: #FFFFFF;
  -webkit-border-radius: 7px;
  -webkit-background-clip: padding-box;
  -moz-border-radius: 7px;
  -moz-background-clip: padding;
  border-radius: 7px;
  background-clip: padding-box;
  display: inline-block;
  margin: 0 auto;
  padding: 10px 20px;
  top: 10%;
  z-index: 9000;
}
</style> 
<script src="//code.jquery.com/jquery-1.11.1.min.js" type="text/javascript"/>
<script src="//cdn.datatables.net/1.10.4/js/jquery.dataTables.min.js" type="text/javascript"/>
<!-- We don't load these as DataTables does not load properly for the below scripts to work
<apex:includeScript value="{!URLFOR($Resource.JQueryZip,'jquery-1.9.1.min.js')}"/>
<apex:includeScript value="{!$Resource.DataTablesJquery}"/>
-->
<apex:includeScript loadOnReady="true" value="{!$Resource.jqueryIsLoading}"/>
<link rel="stylesheet" type="text/css" href="//cdn.datatables.net/1.10.4/css/jquery.dataTables.css" />
<script type="text/javascript"> if (!window.console) console = {log: function() {}}; </script>
<script>

// This function is used to calculate the values for type curve risks, and well profiles
// It takes in a columnNumber that is either 2, 3, 4, or 5, for BOE, oil, ngl or gas. 
// From this column number it calculates which values to update
function calculateColumns(columnNumber) {
    // Create a first pass variable to know if the calculations should
    // use the first row calculations
    var isFirstPass = true;
    // Store the previous proposed profile value for calculations
    var previousProposed;
    // Store the previous type curve value for calculations
    var previousTypeCurve;
    // Variable to store the monthly decline
    var monthlyDecline;
    
    // Here we store the table object as a jquery object
    var table = $('#demo_table');

    // Loop through all of the table rows, don`t include the headers
    table.find('tbody tr').each(function (i, el) {
        // Find the type curve in the correct column for every row
        var $tds = $(this).find('td'),
        // This gets the type curve value for the current row
        typeCurve = parseFloat($tds.eq(columnNumber).text());
        // Store the risk percentage from the borehole object
        var riskPercentage = '{!borehole.Risked__c}';
        var typeRisk;
        // Make sure the risk percentage is not null and the type curve is a valid number
        if(riskPercentage !== null && riskPercentage !== '' && !isNaN(typeCurve)) {
            typeRisk = typeCurve * (riskPercentage/100.0);
            // Insert the calculated risk type and make sure it is to 2 decimal places
            $tds.eq(6).text(Number(typeRisk).toFixed(2));
        } else if((riskPercentage == null || riskPercentage == '') && !isNaN(typeCurve)) {
            typeRisk = typeCurve;
            $tds.eq(6).text(Number(typeRisk).toFixed(2));
        } else {
            // If no risk is found or a number in the calculation is NaN, set to blank
            $tds.eq(6).text('');
        }
        
        // Get the actual and manual values for the correct production type
        // in the correct columns for the current type
        var actual = parseFloat($tds.eq(columnNumber+5).text());
        var manual = parseFloat($tds.eq(columnNumber+10).text());
        
        // Set the proposed and used profile vars to store their values
        var proposed;
        var usedProfile;
        
        // Set proposed to the lowest priority of the risked type curve
        proposed = parseFloat($tds.eq(6).text());
        usedProfile = proposed;
        
        // If not the first pass, do some additional logic on the proposed profile
        if(!isFirstPass) {
            // Calculate the monthly decline
            // Make sure they are both valid numbers
            if(!isNaN(typeCurve) && !isNaN(previousTypeCurve)) {
                monthlyDecline = (previousTypeCurve - typeCurve) / previousTypeCurve;
                // Store the proposed profile and used profile
                proposed = previousProposed - (previousProposed * monthlyDecline);
                usedProfile = proposed;
            } else { 
                // Either the current or previous type curve didn`t exist, so the rest of the 
                // type curve calculations are invalid
                proposed = 0;
                usedProfile = 0;
            }
        }
        // Here we calculate the actuals / manuals if the should take precdence over the risked type curve
        
        // Manual is priority if it is the first pass and an actual does not exist
        if(!isNaN(manual)) {
            if(isFirstPass) {
                proposed = manual;
            }
            // Always set the used profile to manual if actual does not override it
            // Proposed profile doesn`t look at manual unless on first pass
            usedProfile = manual;
        }
        
        // Actual is top priority above everything if it exists
        if(!isNaN(actual)) {
            proposed = actual;
            usedProfile = proposed;
        }
        
        // Make sure proposed is a number and used profile is a number
        // If not then set them both to 0
        if(isNaN(proposed)) {
            proposed = 0;
            usedProfile = proposed;
        }
        
        // Set the first pass to not true after first pass, since logic changes for proposed profile
        isFirstPass = false;
        
        // Set the previous proposed for next round calculations
        previousProposed = proposed;
        // Set the previous type curve for the next round calculations
        previousTypeCurve = typeCurve;
        
        // Set the proposed profile field to 2 decimal places
        $tds.eq(11).text(Number(proposed).toFixed(2));
        
        // Set the used profile field to 2 decimal places
        $tds.eq(16).text(Number(usedProfile).toFixed(2));
    });
}

// Used to reinit the different table settings on change. 
// This makes different columns searchable or not searchable depending 
// on the type selected
function reInitTable(type, table) {
    // Get the current search value if there is one
    var searchText = $('#demo_table_filter').children().first().children().first().val();
    
    // Get the current page
    var currentPage = $('.paginate_button.current').text();
    console.log('the current page is ' + currentPage);
    
    // Get the current number of entries shown
    var numToShow = $('#demo_table_length').children().first().children().first().val();
    console.log('the num to show is ' + numToShow);
    
    // Figure out the record to start on the correct page for pagnation
    var recordToStartOn = (parseInt(currentPage) * parseInt(numToShow)) - parseInt(numToShow);
    
    // Destroy the table, do calculations and reinit table
    table.dataTable().fnDestroy();
    
    // Calculate the columns properly
    calculateColumns(type);
    
    // If reinit the table with the search term if ther was one and paging back on
    // To bring user back to inital search term page
    if(type == 2) {
        // Refresh the table for BOE and only make BOE searchable 
        table.dataTable({
              "iDisplayStart": recordToStartOn,
              "iDisplayLength": parseInt(numToShow),
              "search": {
                 "search": searchText
              },
              "aoColumns": [
                  null,                        // Month                0
                  null,                        // Cal Month            1
                  null,                        // Type Curve - BOE     2
                  { "bSearchable": false },    // Type Curve - Oil     3
                  { "bSearchable": false },    // Type Curve - NGL     4
                  { "bSearchable": false },    // Type Curve - Gas     5
                  null,                        // Risked Type Curve    6
                  null,                        // Actual - BOE         7
                  { "bSearchable": false },    // Actual - Oil         8
                  { "bSearchable": false },    // Actual - NGL         9
                  { "bSearchable": false },    // Actual - Gas         10
                  null,                        // Proposed Profile     11
                  null,                        // Manual - BOE         12
                  { "bSearchable": false },    // Manual - Oil         13
                  { "bSearchable": false },    // Manual - NGL         14
                  { "bSearchable": false },    // Manual - Gas         15
                  null,                        // Used Profile         16
                  { "bSearchable": false }     // SFID                 17
               ]
            });
    } else if(type == 3) {
        // Refresh the table for oil and only make oil searchable  
        table.dataTable({
              "iDisplayStart": recordToStartOn,
              "iDisplayLength": parseInt(numToShow),
              "search": {
                 "search": searchText
              },
              "aoColumns": [
                  null,                        // Month
                  null,                        // Cal Month
                  { "bSearchable": false },    // Type Curve - BOE
                  null,                        // Type Curve - Oil
                  { "bSearchable": false },    // Type Curve - NGL
                  { "bSearchable": false },    // Type Curve - Gas
                  null,                        // Risked Type Curve
                  { "bSearchable": false },    // Actual - BOE
                  null,                        // Actual - Oil
                  { "bSearchable": false },    // Actual - NGL
                  { "bSearchable": false },    // Actual - Gas
                  null,                        // Proposed Profile
                  { "bSearchable": false },    // Manual - BOE
                  null,                        // Manual - Oil
                  { "bSearchable": false },    // Manual - NGL
                  { "bSearchable": false },    // Manual - Gas
                  null,                        // Used Profile
                  { "bSearchable": false }     // SFID
               ]
            });
    } else if(type == 4) {
         // Refresh the table for NGL and only make NGL searchable   
         table.dataTable({
           "iDisplayStart": recordToStartOn,
           "iDisplayLength": parseInt(numToShow),
           "search": {
               "search": searchText
           },
           "aoColumns": [
                  null,                        // Month
                  null,                        // Cal Month
                  { "bSearchable": false },    // Type Curve - BOE
                  { "bSearchable": false },    // Type Curve - Oil
                  null,                        // Type Curve - NGL
                  { "bSearchable": false },    // Type Curve - Gas
                  null,                        // Risked Type Curve
                  { "bSearchable": false },    // Actual - BOE
                  { "bSearchable": false },    // Actual - Oil
                  null,                        // Actual - NGL
                  { "bSearchable": false },    // Actual - Gas
                  null,                        // Proposed Profile
                  { "bSearchable": false },    // Manual - BOE
                  { "bSearchable": false },    // Manual - Oil
                  null,                        // Manual - NGL
                  { "bSearchable": false },    // Manual - Gas
                  null,                        // Used Profile
                  { "bSearchable": false }     // SFID
            ]
         });
    } else if(type == 5) {
         // Refresh the table for gas and only make gas searchable   
         table.dataTable({
           "iDisplayStart": recordToStartOn,
           "iDisplayLength": parseInt(numToShow),
           "search": {
               "search": searchText
           },
           "aoColumns": [
                  null,                        // Month
                  null,                        // Cal Month
                  { "bSearchable": false },    // Type Curve - BOE
                  { "bSearchable": false },    // Type Curve - Oil
                  { "bSearchable": false },    // Type Curve - NGL
                  null,                        // Type Curve - Gas
                  null,                        // Risked Type Curve
                  { "bSearchable": false },    // Actual - BOE
                  { "bSearchable": false },    // Actual - Oil
                  { "bSearchable": false },    // Actual - NGL
                  null,                        // Actual - Gas
                  null,                        // Proposed Profile
                  { "bSearchable": false },    // Manual - BOE
                  { "bSearchable": false },    // Manual - Oil
                  { "bSearchable": false },    // Manual - NGL
                  null,                        // Manual - Gas
                  null,                        // Used Profile
                  { "bSearchable": false }     // SFID
            ]
         });
    }
}

var type;

// Make sure the page has loaded
$(document).ready(function(){

    /***********************
     ** START TABLE SETUP **
     ***********************/
    // Init the table variable
    var table = $('#demo_table');
    // Set the production type to 2 (BOE)
    type = 2;
    
    // Hide the salesforce column always
    $(".SFID").hide();
    
    // Used to store override element selector later
    var manualOverrideElement;
    
    // Fill in the values in the table for the oil type curve and profile values
    // 2 = BOE, 3 = oil, 4 = ngl, 5 = gas
    calculateColumns(type);
    
    // Build the table with the updated values
    table.dataTable({
        destroy: true,
        "aoColumns": [
                  null,                        // Month                0
                  null,                        // Cal Month            1
                  null,                        // Type Curve - BOE     2
                  { "bSearchable": false },    // Type Curve - Oil     3
                  { "bSearchable": false },    // Type Curve - NGL     4
                  { "bSearchable": false },    // Type Curve - Gas     5
                  null,                        // Risked Type Curve    6
                  null,                        // Actual - BOE         7
                  { "bSearchable": false },    // Actual - Oil         8
                  { "bSearchable": false },    // Actual - NGL         9
                  { "bSearchable": false },    // Actual - Gas         10
                  null,                        // Proposed Profile     11
                  null,                        // Manual - BOE         12
                  { "bSearchable": false },    // Manual - Oil         13
                  { "bSearchable": false },    // Manual - NGL         14
                  { "bSearchable": false },    // Manual - Gas         15
                  null,                        // Used Profile         16
                  { "bSearchable": false }     // SFID                 17
         ]
    });
    
    /***********************
     ** END TABLE SETUP ****
     ***********************/
    
    /*******************
     ** LISTENERS ******
     *******************/
    
    // Watch the select dropdown for changes, and modify the typecurve and recalculate the 
    // Proposed profile, used profile, and typecurve risk
    $('#production_type').change(function(){ 
      // Oil
      if ($(this).val() == 'boe') {
         // Hide the ngl and gas columns
         type = 2;
         // Type curves
         $(".type_curve_boe").show();
         $(".type_curve_oil").hide();
         $(".type_curve_ngl").hide();
         $(".type_curve_gas").hide();
         // Actuals
         $(".actual_boe").show();
         $(".actual_oil").hide();
         $(".actual_ngl").hide();
         $(".actual_gas").hide();
         // Manuals
         $(".manual_boe").show();
         $(".manual_oil").hide();
         $(".manual_ngl").hide();
         $(".manual_gas").hide();
         reInitTable(type, table);
      }
      if ($(this).val() == 'oil') {
         // Hide the ngl and gas columns
         type = 3;
         // Type curves
         $(".type_curve_boe").hide();
         $(".type_curve_oil").show();
         $(".type_curve_ngl").hide();
         $(".type_curve_gas").hide();
         // Actuals
         $(".actual_boe").hide();
         $(".actual_oil").show();
         $(".actual_ngl").hide();
         $(".actual_gas").hide();
         // Manuals
         $(".manual_boe").hide();
         $(".manual_oil").show();
         $(".manual_ngl").hide();
         $(".manual_gas").hide();
         reInitTable(type, table);
      }
      // NGL
      if ($(this).val() == 'ngl') {
         // Hide the oil and gas columns
         type = 4;
         // Type curves
         $(".type_curve_boe").hide();
         $(".type_curve_oil").hide();
         $(".type_curve_ngl").show();
         $(".type_curve_gas").hide();
         // Actuals
         $(".actual_boe").hide();
         $(".actual_oil").hide();
         $(".actual_ngl").show();
         $(".actual_gas").hide();
         // Manuals
         $(".manual_boe").hide();
         $(".manual_oil").hide();
         $(".manual_ngl").show();
         $(".manual_gas").hide();
         reInitTable(type, table);
      }
      // Gas
      if ($(this).val() == 'gas') {
         // Hide the ngl and oil columns
         type = 5;
          // Type curves
         $(".type_curve_boe").hide();
         $(".type_curve_oil").hide();
         $(".type_curve_ngl").hide();
         $(".type_curve_gas").show();
         // Actuals
         $(".actual_boe").hide();
         $(".actual_oil").hide();
         $(".actual_ngl").hide();
         $(".actual_gas").show();
         // Manuals
         $(".manual_boe").hide();
         $(".manual_oil").hide();
         $(".manual_ngl").hide();
         $(".manual_gas").show();
         reInitTable(type, table);
      } 
    });
    
    // If number of entries to show is changed, reinit table.
    $('#demo_table').on('length.dt',function(e, settings, len)
                                    {
                                      // Oil
                                      if ($('#production_type').val() == 'boe') {
                                         // Hide the ngl and gas columns
                                         type = 2;
                                         reInitTable(type, table);
                                         // Type curves
                                         $(".type_curve_boe").show();
                                         $(".type_curve_oil").hide();
                                         $(".type_curve_ngl").hide();
                                         $(".type_curve_gas").hide();
                                         // Actuals
                                         $(".actual_boe").show();
                                         $(".actual_oil").hide();
                                         $(".actual_ngl").hide();
                                         $(".actual_gas").hide();
                                         // Manuals
                                         $(".manual_boe").show();
                                         $(".manual_oil").hide();
                                         $(".manual_ngl").hide();
                                         $(".manual_gas").hide();
                                      }
                                      if ($('#production_type').val() == 'oil') {
                                         // Hide the ngl and gas columns
                                         type = 3;
                                         reInitTable(type, table);
                                         // Type curves
                                         $(".type_curve_boe").hide();
                                         $(".type_curve_oil").show();
                                         $(".type_curve_ngl").hide();
                                         $(".type_curve_gas").hide();
                                         // Actuals
                                         $(".actual_boe").hide();
                                         $(".actual_oil").show();
                                         $(".actual_ngl").hide();
                                         $(".actual_gas").hide();
                                         // Manuals
                                         $(".manual_boe").hide();
                                         $(".manual_oil").show();
                                         $(".manual_ngl").hide();
                                         $(".manual_gas").hide();
                                      }
                                      // NGL
                                      if ($('#production_type').val() == 'ngl') {
                                         // Hide the oil and gas columns
                                         type = 4;
                                         reInitTable(type, table);
                                         // Type curves
                                         $(".type_curve_boe").hide();
                                         $(".type_curve_oil").hide();
                                         $(".type_curve_ngl").show();
                                         $(".type_curve_gas").hide();
                                         // Actuals
                                         $(".actual_boe").hide();
                                         $(".actual_oil").hide();
                                         $(".actual_ngl").show();
                                         $(".actual_gas").hide();
                                         // Manuals
                                         $(".manual_boe").hide();
                                         $(".manual_oil").hide();
                                         $(".manual_ngl").show();
                                         $(".manual_gas").hide();
                                      }
                                      // Gas
                                      if ($('#production_type').val() == 'gas') {
                                         // Hide the ngl and oil columns
                                         type = 5;
                                         reInitTable(type, table);
                                          // Type curves
                                         $(".type_curve_boe").hide();
                                         $(".type_curve_oil").hide();
                                         $(".type_curve_ngl").hide();
                                         $(".type_curve_gas").show();
                                         // Actuals
                                         $(".actual_boe").hide();
                                         $(".actual_oil").hide();
                                         $(".actual_ngl").hide();
                                         $(".actual_gas").show();
                                         // Manuals
                                         $(".manual_boe").hide();
                                         $(".manual_oil").hide();
                                         $(".manual_ngl").hide();
                                         $(".manual_gas").show();
                                      }});
    
    // If page # is changed, reinit table
    $('#demo_table').on('draw.dt',function()
                                    {
                                      // Oil
                                      if ($('#production_type').val() == 'boe') {
                                         // Hide the ngl and gas columns
                                         type = 2;
                                         // Type curves
                                         $(".type_curve_boe").show();
                                         $(".type_curve_oil").hide();
                                         $(".type_curve_ngl").hide();
                                         $(".type_curve_gas").hide();
                                         // Actuals
                                         $(".actual_boe").show();
                                         $(".actual_oil").hide();
                                         $(".actual_ngl").hide();
                                         $(".actual_gas").hide();
                                         // Manuals
                                         $(".manual_boe").show();
                                         $(".manual_oil").hide();
                                         $(".manual_ngl").hide();
                                         $(".manual_gas").hide();
                                      }
                                      if ($('#production_type').val() == 'oil') {
                                         // Hide the ngl and gas columns
                                         type = 3;
                                         // Type curves
                                         $(".type_curve_boe").hide();
                                         $(".type_curve_oil").show();
                                         $(".type_curve_ngl").hide();
                                         $(".type_curve_gas").hide();
                                         // Actuals
                                         $(".actual_boe").hide();
                                         $(".actual_oil").show();
                                         $(".actual_ngl").hide();
                                         $(".actual_gas").hide();
                                         // Manuals
                                         $(".manual_boe").hide();
                                         $(".manual_oil").show();
                                         $(".manual_ngl").hide();
                                         $(".manual_gas").hide();
                                      }
                                      // NGL
                                      if ($('#production_type').val() == 'ngl') {
                                         // Hide the oil and gas columns
                                         type = 4;
                                         // Type curves
                                         $(".type_curve_boe").hide();
                                         $(".type_curve_oil").hide();
                                         $(".type_curve_ngl").show();
                                         $(".type_curve_gas").hide();
                                         // Actuals
                                         $(".actual_boe").hide();
                                         $(".actual_oil").hide();
                                         $(".actual_ngl").show();
                                         $(".actual_gas").hide();
                                         // Manuals
                                         $(".manual_boe").hide();
                                         $(".manual_oil").hide();
                                         $(".manual_ngl").show();
                                         $(".manual_gas").hide();
                                      }
                                      // Gas
                                      if ($('#production_type').val() == 'gas') {
                                         // Hide the ngl and oil columns
                                         type = 5;
                                          // Type curves
                                         $(".type_curve_boe").hide();
                                         $(".type_curve_oil").hide();
                                         $(".type_curve_ngl").hide();
                                         $(".type_curve_gas").show();
                                         // Actuals
                                         $(".actual_boe").hide();
                                         $(".actual_oil").hide();
                                         $(".actual_ngl").hide();
                                         $(".actual_gas").show();
                                         // Manuals
                                         $(".manual_boe").hide();
                                         $(".manual_oil").hide();
                                         $(".manual_ngl").hide();
                                         $(".manual_gas").show();
                                      }});
    
    // Table editing listener, this allows the manual override to be editable
    // has a remote callback to salesforce controller which recieves a response 
    // as well
    $("#demo_table tbody").on("dblclick", ".manual_oil, .manual_ngl, .manual_gas", function (){
        // Store the original content variable
        var OriginalContent = $(this).text();
        
        // Figure out the row so we can get the month and SFID
        var row = parseInt($(this).parent().parent().children().index($(this).parent()));
        row++;
        
        // Here we grab the month for the correct row as found earlier
        var month = $("#demo_table tr:eq("+row+") > td:eq(1)").text();
        
        // Here we grab the SFID for the correct row as found earlier
        var SFID = $("#demo_table tr:eq("+row+") > td:eq(17)").text();

        // Add an input to the current cell to allow the user to change the value
        $(this).html("<input style='margin: 0; padding: 0; width:90%;' type='text' maxlength='8' value='" + OriginalContent + "' />");
        // Focus the input 
        $(this).children().first().focus(); 

        // This function saves the value on enter keypress, by calling a salesforce remote function
        // and waiting for a callback. 
        $(this).children().first().keypress(function (e) {
            if (e.which == 13) {
                // Store the current cell as a jquery object for use in the callback function
                manualOverrideElement = $(this);
                // Get the value of the new manual override entered
                var newContent = $(this).val(); 
                
                // If the content didn`t change, just remove the input field and return
                if(newContent == OriginalContent)
                {
                    $(this).parent().text(OriginalContent); 
                    return;
                }
                
                // If user enters a non number value, don`t try to save it
                // and alert the user
                if(isNaN(newContent)) {
                    manualOverrideElement.parent().text(OriginalContent);
                    alert("Please enter a valid number");
                } else {
                
                    // Get name of the production type for the XML generation
                    var productionTypeName;
                    if(type == 3) {
                        productionTypeName = 'OIL';
                    } else if (type == 4) {
                        productionTypeName = 'NGL';
                    } else if (type == 5) {
                        productionTypeName = 'GAS';
                    }
                    
                    // Overlay the table with a saving message using the isLoading library
                    table.parent().isLoading({
                        text:       "Saving Manual Override...",
                        position:   "overlay"
                    });
                    
                    // This is the action we`re performing. If a value is changed, it`s UPDATE, if a value was blank and is now filled it`s CREATE, if a value was filled and is now blank it`s DELETE
                    var action = '';
                    if(newContent != '' && OriginalContent == '')
                    {
                        action = 'CREATE';
                    }
                    else if(newContent == '' && OriginalContent != '')
                    {
                        action = 'DELETE';
                    }
                    else
                    {
                        action = 'UPDATE';
                    }
                    
                    var actionSuccess = false;
                    if(SFID == '')
                    {
                        
                            // Create the SF record
                            Visualforce.remoting.Manager.invokeAction(
                                '{!$RemoteAction.BoreholeProductionXML.createWellProduction}',
                                $('#boreholeId').text(), month, productionTypeName, newContent,
                                function(result, event){
                                    if (event.status) {
                                        console.log(result);
                                        $("#demo_table tr:eq("+row+") > td:eq(17)").text(result);
                                        SFID = $("#demo_table tr:eq("+row+") > td:eq(17)").text();
                                        // Invoke remote JS callback to controller when user hits enter
                                        Visualforce.remoting.Manager.invokeAction(
                                            '{!$RemoteAction.BoreholeProductionXML.XMLWellProduction}',
                                            SFID, action, month, productionTypeName, newContent, '{!borehole.GRD_GUID__c}', '', 'WCP_SC', 
                                            function(result, event){
                                                if (event.status) {
                                                    
                                                    // Was the XML update successful, or failed?
                                                    if(result.hasOwnProperty('Fail') && result.Fail.length > 0)
                                                    {
                                                        // Un-update the SF record
                                                        Visualforce.remoting.Manager.invokeAction(
                                                            '{!$RemoteAction.BoreholeProductionXML.updateWellProduction}',
                                                            $('#boreholeId').text(), SFID, productionTypeName, null,
                                                            function(result, event){
                                                                if (event.status) {
                                                                    console.log(result);
                                                                } else if (event.type === 'exception') {
                                                                    console.log(event.message);
                                                                    alert(event.message);
                                                                } else {
                                                                    console.log(event.message);
                                                                    alert(event.message);
                                                                }
                                                            },
                                                            {escape: false} // Make sure the return value is not escaped
                                                        );
                                                        
                                                        // Color the cell border red for FAILURE
                                                        manualOverrideElement.parent().css("border", "2px solid red");
                                                        // Replace with original text
                                                        manualOverrideElement.parent().text(OriginalContent);
                                                        alert(result.Fail[0][1]);
                                                        // Reinit table first, then calculate the columns (keeps calculation order)
                                                        reInitTable(type, table);
                                                        // Hide the loading overlay
                                                        table.parent().isLoading( "hide" );
                                                    }
                                                    else
                                                    {
                                                        console.log(result);
                                                        // Color the cell border green for OK
                                                        manualOverrideElement.parent().css("border", "2px solid rgb(103, 218, 63)");
                                                        // Replace with new text
                                                        manualOverrideElement.parent().text(Number(newContent).toFixed(2));
                                                        
                                                        // Recalc BOE for this row
                                                        
                                                        var oilOverrideValue = $("#demo_table tr:eq("+row+") > td:eq(13)").text();
                                                        var nglOverrideValue = $("#demo_table tr:eq("+row+") > td:eq(14)").text();
                                                        var gasOverrideValue = $("#demo_table tr:eq("+row+") > td:eq(15)").text();
                                                        
                                                        if(oilOverrideValue != null && oilOverrideValue != '' && !isNaN(oilOverrideValue))
                                                            oilOverrideValue = Number(oilOverrideValue).toFixed(2);
                                                        else
                                                            oilOverrideValue = 0;
                                                        
                                                        if(nglOverrideValue != null && nglOverrideValue != '' && !isNaN(nglOverrideValue))
                                                            nglOverrideValue = Number(nglOverrideValue).toFixed(2);
                                                        else
                                                            nglOverrideValue = 0;
                                                        
                                                        if(gasOverrideValue != null && gasOverrideValue != '' && !isNaN(gasOverrideValue))
                                                            gasOverrideValue = Number(gasOverrideValue).toFixed(2);
                                                        else
                                                            gasOverrideValue = 0;
console.log('oilOverrideValue '+oilOverrideValue);
console.log('nglOverrideValue '+nglOverrideValue);
console.log('gasOverrideValue '+gasOverrideValue);
console.log('BOE '+(oilOverrideValue+nglOverrideValue+(gasOverrideValue/6.0)));
                                                        $("#demo_table tr:eq("+row+") > td:eq(12)").text((oilOverrideValue+nglOverrideValue+(gasOverrideValue/6.0)));
                                                        
                                                        
                                                        
                                                        
                                                        
                                                        
                                                        
                                                        
                                                        
                                                        
                                                        
                                                        
                                                        // Reinit table first, then calculate the columns (keeps calculation order)
                                                        reInitTable(type, table);
                                                        // Hide the loading overlay
                                                        table.parent().isLoading( "hide" );
                                                    }
                                                } else if (event.type === 'exception') {
                                                    console.log(event.message);
                                                    // Color the cell border red for FAILURE
                                                    manualOverrideElement.parent().css("border", "2px solid red");
                                                    // Replace with original text
                                                    manualOverrideElement.parent().text(OriginalContent); 
                                                    
                                                    alert(event.message);
                                                    
                                                    // Hide the loading overlay
                                                    table.parent().isLoading( "hide" );
                                                } else {
                                                    console.log(event.message);
                                                     // Color the cell border red for FAILURE
                                                    manualOverrideElement.parent().css("border", "2px solid red");
                                                    // Replace with original text
                                                    manualOverrideElement.parent().text(OriginalContent);
                                                    
                                                    alert(event.message);
                                                    
                                                    // Hide the loading overlay
                                                    table.parent().isLoading( "hide" );
                                                }
                                            },
                                            {escape: false} // Make sure the return value is not escaped
                                        );
                                    } else if (event.type === 'exception') {
                                        console.log(event.message);
                                        // Color the cell border red for FAILURE
                                        manualOverrideElement.parent().css("border", "2px solid red");
                                        // Replace with original text
                                        manualOverrideElement.parent().text(OriginalContent);
                                        
                                        alert(event.message);
                                        
                                        // Hide the loading overlay
                                        table.parent().isLoading( "hide" );
                                    } else {
                                        console.log(event.message);
                                         // Color the cell border red for FAILURE
                                        manualOverrideElement.parent().css("border", "2px solid red");
                                        // Replace with original text
                                        manualOverrideElement.parent().text(OriginalContent);
                                        
                                        alert(event.message);
                                        
                                        // Hide the loading overlay
                                        table.parent().isLoading( "hide" );
                                    }
                                },
                                {escape: false} // Make sure the return value is not escaped
                            );
                    }
                    else
                    {
                        if(action == 'UPDATE' || action == 'CREATE')
                        {
                            
                            // Update the SF record
                            Visualforce.remoting.Manager.invokeAction(
                                '{!$RemoteAction.BoreholeProductionXML.updateWellProduction}',
                                $('#boreholeId').text(), SFID, productionTypeName, newContent,
                                function(result, event){
                                    if (event.status) {
                                        console.log('1 '+result);
                                        // Invoke remote JS callback to controller when user hits enter
                                        Visualforce.remoting.Manager.invokeAction(
                                            '{!$RemoteAction.BoreholeProductionXML.XMLWellProduction}',
                                            SFID, action, month, productionTypeName, newContent, '{!borehole.GRD_GUID__c}', '', 'WCP_SC', 
                                            function(result, event){
                                                if (event.status) {
                                                    console.log(result);
                                                    // Was the XML update successful, or failed?
                                                    if(result.hasOwnProperty('Fail') && result.Fail.length > 0)
                                                    {
                                                        // Un-update the SF record
                                                        Visualforce.remoting.Manager.invokeAction(
                                                            '{!$RemoteAction.BoreholeProductionXML.updateWellProduction}',
                                                            $('#boreholeId').text(), SFID, productionTypeName, OriginalContent,
                                                            function(result, event){
                                                                if (event.status) {
                                                                    console.log(result);
                                                                } else if (event.type === 'exception') {
                                                                    console.log(event.message);
                                                                    alert(event.message);
                                                                } else {
                                                                    console.log(event.message);
                                                                    alert(event.message);
                                                                }
                                                            },
                                                            {escape: false} // Make sure the return value is not escaped
                                                        ); 
                                                        // Color the cell border red for FAILURE
                                                        manualOverrideElement.parent().css("border", "2px solid red");
                                                        // Replace with original text
                                                        manualOverrideElement.parent().text(OriginalContent);
                                                        alert(result.Fail[0][1]);
                                                        // Reinit table first, then calculate the columns (keeps calculation order)
                                                        reInitTable(type, table);
                                                        // Hide the loading overlay
                                                        table.parent().isLoading( "hide" );
                                                    }
                                                    else
                                                    {
                                                        // Color the cell border green for OK
                                                        manualOverrideElement.parent().css("border", "2px solid rgb(103, 218, 63)");
                                                        // Replace with new text
                                                        manualOverrideElement.parent().text(Number(newContent).toFixed(2));
                                                        
                                                        
                                                        
                                                        // Recalc BOE for this row
                                                        
                                                        var oilOverrideValue = $("#demo_table tr:eq("+row+") > td:eq(13)").text();
                                                        var nglOverrideValue = $("#demo_table tr:eq("+row+") > td:eq(14)").text();
                                                        var gasOverrideValue = $("#demo_table tr:eq("+row+") > td:eq(15)").text();
                                                        
                                                        if(oilOverrideValue != null && oilOverrideValue != '' && !isNaN(oilOverrideValue))
                                                            oilOverrideValue = Number(oilOverrideValue).toFixed(2);
                                                        else
                                                            oilOverrideValue = 0;
                                                        
                                                        if(nglOverrideValue != null && nglOverrideValue != '' && !isNaN(nglOverrideValue))
                                                            nglOverrideValue = Number(nglOverrideValue).toFixed(2);
                                                        else
                                                            nglOverrideValue = 0;
                                                        
                                                        if(gasOverrideValue != null && gasOverrideValue != '' && !isNaN(gasOverrideValue))
                                                            gasOverrideValue = Number(gasOverrideValue).toFixed(2);
                                                        else
                                                            gasOverrideValue = 0;
console.log('oilOverrideValue '+oilOverrideValue);
console.log('nglOverrideValue '+nglOverrideValue);
console.log('gasOverrideValue '+gasOverrideValue);
console.log('BOE '+(oilOverrideValue+nglOverrideValue+(gasOverrideValue/6.0)));
                                                        $("#demo_table tr:eq("+row+") > td:eq(12)").text((oilOverrideValue+nglOverrideValue+(gasOverrideValue/6.0)));
                                                        
                                                        
                                                        
                                                        // Reinit table first, then calculate the columns (keeps calculation order)
                                                        reInitTable(type, table);
                                                        // Hide the loading overlay
                                                        table.parent().isLoading( "hide" );
                                                    }
                                                } else if (event.type === 'exception') {
                                                    console.log(event.message);
                                                    // Color the cell border red for FAILURE
                                                    manualOverrideElement.parent().css("border", "2px solid red");
                                                    // Replace with original text
                                                    manualOverrideElement.parent().text(OriginalContent); 
                                                    alert(event.message);
                                                    // Hide the loading overlay
                                                    table.parent().isLoading( "hide" );
                                                } else {
                                                    console.log(event.message);
                                                     // Color the cell border red for FAILURE
                                                    manualOverrideElement.parent().css("border", "2px solid red");
                                                    // Replace with original text
                                                    manualOverrideElement.parent().text(OriginalContent); 
                                                    alert(event.message);
                                                    // Hide the loading overlay
                                                    table.parent().isLoading( "hide" );
                                                }
                                            },
                                            {escape: false} // Make sure the return value is not escaped
                                        );
                                    } else if (event.type === 'exception') {
                                        console.log(event.message);
                                        // Color the cell border red for FAILURE
                                        manualOverrideElement.parent().css("border", "2px solid red");
                                        // Replace with original text
                                        manualOverrideElement.parent().text(OriginalContent); 
                                        alert(event.message);
                                        // Hide the loading overlay
                                        table.parent().isLoading( "hide" );
                                    } else {
                                        console.log(event.message);
                                         // Color the cell border red for FAILURE
                                        manualOverrideElement.parent().css("border", "2px solid red");
                                        // Replace with original text
                                        manualOverrideElement.parent().text(OriginalContent); 
                                        alert(event.message);
                                        // Hide the loading overlay
                                        table.parent().isLoading( "hide" );
                                    }
                                },
                                {escape: false} // Make sure the return value is not escaped
                            );
                        }
                        else
                        {
console.log('DELETE');
console.log('action = '+action);
                            // Update the SF record
                            Visualforce.remoting.Manager.invokeAction(
                                '{!$RemoteAction.BoreholeProductionXML.updateWellProduction}',
                                $('#boreholeId').text(), SFID, productionTypeName, null,
                                function(result, event){
                                    if (event.status) {
                                        console.log('1 '+result);
                                        // Invoke remote JS callback to controller when user hits enter
                                        Visualforce.remoting.Manager.invokeAction(
                                            '{!$RemoteAction.BoreholeProductionXML.XMLWellProduction}',
                                            SFID, action, month, productionTypeName, newContent, '{!borehole.GRD_GUID__c}', 'mikeporter@mikeporter.com', 'WCP_SC', 
                                            function(result, event){
                                                if (event.status) {
                                                    // Was the XML update successful, or failed?
                                                    if(result.hasOwnProperty('Fail') && result.Fail.length > 0)
                                                    {
                                                        // Un-update the SF record
                                                        Visualforce.remoting.Manager.invokeAction(
                                                            '{!$RemoteAction.BoreholeProductionXML.updateWellProduction}',
                                                            $('#boreholeId').text(), SFID, productionTypeName, OriginalContent,
                                                            function(result, event){
                                                                if (event.status) {
                                                                    console.log(result);
                                                                } else if (event.type === 'exception') {
                                                                    console.log(event.message);
                                                                    alert(event.message);
                                                                } else {
                                                                    console.log(event.message);
                                                                    alert(event.message);
                                                                }
                                                            },
                                                            {escape: false} // Make sure the return value is not escaped
                                                        ); 
                                                        // Color the cell border red for FAILURE
                                                        manualOverrideElement.parent().css("border", "2px solid red");
                                                        // Replace with original text
                                                        manualOverrideElement.parent().text(OriginalContent);
                                                        alert(result.Fail[0][1]);
                                                        // Reinit table first, then calculate the columns (keeps calculation order)
                                                        reInitTable(type, table);
                                                        // Hide the loading overlay
                                                        table.parent().isLoading( "hide" );
                                                    }
                                                    else
                                                    {
                                                        // Color the cell border green for OK
                                                        manualOverrideElement.parent().css("border", "2px solid rgb(103, 218, 63)");
                                                        // Replace with new text
                                                        manualOverrideElement.parent().text(Number(newContent).toFixed(2));
                                                        
                                                        // Recalc BOE for this row
                                                        
                                                        var oilOverrideValue = $("#demo_table tr:eq("+row+") > td:eq(13)").text();
                                                        var nglOverrideValue = $("#demo_table tr:eq("+row+") > td:eq(14)").text();
                                                        var gasOverrideValue = $("#demo_table tr:eq("+row+") > td:eq(15)").text();
                                                        
                                                        if(oilOverrideValue != null && oilOverrideValue != '' && !isNaN(oilOverrideValue))
                                                            oilOverrideValue = Number(oilOverrideValue).toFixed(2);
                                                        else
                                                            oilOverrideValue = 0;
                                                        
                                                        if(nglOverrideValue != null && nglOverrideValue != '' && !isNaN(nglOverrideValue))
                                                            nglOverrideValue = Number(nglOverrideValue).toFixed(2);
                                                        else
                                                            nglOverrideValue = 0;
                                                        
                                                        if(gasOverrideValue != null && gasOverrideValue != '' && !isNaN(gasOverrideValue))
                                                            gasOverrideValue = Number(gasOverrideValue).toFixed(2);
                                                        else
                                                            gasOverrideValue = 0;
console.log('oilOverrideValue '+oilOverrideValue);
console.log('nglOverrideValue '+nglOverrideValue);
console.log('gasOverrideValue '+gasOverrideValue);
console.log('BOE '+(oilOverrideValue+nglOverrideValue+(gasOverrideValue/6.0)));
                                                        $("#demo_table tr:eq("+row+") > td:eq(12)").text((oilOverrideValue+nglOverrideValue+(gasOverrideValue/6.0)));
                                                        
                                                        
                                                        
                                                        // Reinit table first, then calculate the columns (keeps calculation order)
                                                        reInitTable(type, table);
                                                        // Hide the loading overlay
                                                        table.parent().isLoading( "hide" );
                                                    }
                                                } else if (event.type === 'exception') {
                                                    console.log(event.message);
                                                    // Color the cell border red for FAILURE
                                                    manualOverrideElement.parent().css("border", "2px solid red");
                                                    // Replace with original text
                                                    manualOverrideElement.parent().text(OriginalContent); 
                                                    alert(event.message);
                                                    // Hide the loading overlay
                                                    table.parent().isLoading( "hide" );
                                                } else {
                                                    console.log(event.message);
                                                     // Color the cell border red for FAILURE
                                                    manualOverrideElement.parent().css("border", "2px solid red");
                                                    // Replace with original text
                                                    manualOverrideElement.parent().text(OriginalContent); 
                                                    alert(event.message);
                                                    // Hide the loading overlay
                                                    table.parent().isLoading( "hide" );
                                                }
                                            },
                                            {escape: false} // Make sure the return value is not escaped
                                        );
                                    } else if (event.type === 'exception') {
                                        console.log(event.message);
                                        // Color the cell border red for FAILURE
                                        manualOverrideElement.parent().css("border", "2px solid red");
                                        // Replace with original text
                                        manualOverrideElement.parent().text(OriginalContent); 
                                        alert(event.message);
                                        // Hide the loading overlay
                                        table.parent().isLoading( "hide" );
                                    } else {
                                        console.log(event.message);
                                         // Color the cell border red for FAILURE
                                        manualOverrideElement.parent().css("border", "2px solid red");
                                        // Replace with original text
                                        manualOverrideElement.parent().text(OriginalContent); 
                                        alert(event.message);
                                        // Hide the loading overlay
                                        table.parent().isLoading( "hide" );
                                    }
                                },
                                {escape: false} // Make sure the return value is not escaped
                            );
                        }
                    }
                }
            } 
        }); 
    
        // If the user clicks out before hitting enter, replace text with original text
        $(this).children().first().blur(function(){ 
            $(this).parent().text(OriginalContent); 
        });
    });
});
</script>
    <apex:outputPanel rendered="{!borehole == null}">
        <apex:pageMessage title="No borehole found" summary="This page displays Production information for a WCP borehole. No borehole was requested, or the requested borehole was not found." severity="error" strength="3"/>
    </apex:outputPanel>
    <apex:outputPanel rendered="{!AND(borehole != null,borehole.Target_Formation__c == null)}">
        <apex:pageMessage title="No formation found" summary="The requested borehole has no target formation. Cannot proceed." severity="error" strength="2"/>
    </apex:outputPanel>
    <apex:outputPanel rendered="{!AND(borehole != null,borehole.Pool__c == null)}">
        <apex:pageMessage title="No pool found" summary="The requested borehole has no pool. Cannot proceed." severity="error" strength="2"/>
    </apex:outputPanel>
    <apex:outputPanel rendered="{!AND(borehole != null,OR(borehole.Well_Orientation__c == null,borehole.Well_Orientation__c == ''))}">
        <apex:pageMessage title="No orientation found" summary="The requested borehole has no orientation. Cannot proceed." severity="error" strength="2"/>
    </apex:outputPanel>
    <apex:outputPanel rendered="{!type_curve_list.size == 0}">
        <apex:pageMessage title="No type curves found" summary="No type curves have been associated with the well. Cannot proceed." severity="error" strength="2"/>
    </apex:outputPanel>
    <apex:outputPanel rendered="{!AND(borehole != null,borehole.Target_Formation__c != null,borehole.Pool__c != null,borehole.Well_Orientation__c != null,type_curve_list.size > 0)}">
        <apex:pageBlock >
            <apex:pageBlockSection columns="2">
                <apex:pageBlockSectionItem >
                                    <apex:outputLabel value="Target Formation"/>
                                    <apex:outputText value="{!borehole.Target_Formation__c}"/>
                </apex:pageBlockSectionItem>
                <apex:pageBlockSectionItem >
                                    <apex:outputLabel value="Pool"/>
                                    <apex:outputText value="{!borehole.Pool__c}"/>
                </apex:pageBlockSectionItem>
                <apex:pageBlockSectionItem >
                                    <apex:outputLabel value="Well Orientation"/>
                                    <apex:outputText value="{!borehole.Well_Orientation__c}"/>
                </apex:pageBlockSectionItem>
                <apex:pageBlockSectionItem >
                    <apex:outputLabel value="Strategy"/>
                    <apex:outputText value="{!borehole.Strategy__c}"/>
                </apex:pageBlockSectionItem>
                <apex:pageBlockSectionItem >
                    <apex:outputLabel value="Curve Date"/>
                    <apex:outputText value="{0,date,MMMM d',' yyyy}">
                        <apex:param value="{!type_curve_list[0].Curve_Date__c}" /> 
                    </apex:outputText>
                </apex:pageBlockSectionItem>
<!--
                <apex:pageBlockSectionItem >
                    <apex:outputLabel value="Created By"/>
                    <apex:outputText value="{!borehole.CreatedBy.Name}"/>
                </apex:pageBlockSectionItem>
-->
                <apex:pageBlockSectionItem >
                    <apex:outputLabel value="Risked"/>
                    <apex:outputPanel >
                        <apex:outputPanel rendered="{!borehole.Risked__c != null}">
                            <apex:outputText value="{!borehole.Risked__c}%"/>
                        </apex:outputPanel>
                        <apex:outputPanel rendered="{!borehole.Risked__c == null}">
                            <apex:outputText value="Unknown; assuming 100%" style="font-style:italic"/>
                        </apex:outputPanel>
                    </apex:outputPanel>
                </apex:pageBlockSectionItem>
            </apex:pageBlockSection>
        </apex:pageBlock>
        <span id="boreholeId" style="display:none">{!borehole.Id}</span>
        <table id="demo_table" class="display">
            <select id="production_type" style="margin: 0 0 10px;">
              <option value="boe">BOE</option>
              <option value="oil">Oil</option>
              <option value="ngl">NGL</option>
              <option value="gas">Gas</option>
            </select>
            <thead>
                <tr>
                    <th class="month">Months</th>
                    <th class="cal_month">Calender Month</th>
                    <th class="type_curve_boe">Type Curve</th>
                    <th class="type_curve_oil" style="display:none;">Type Curve</th>
                    <th class="type_curve_ngl" style="display:none;">Type Curve</th>
                    <th class="type_curve_gas" style="display:none;">Type Curve</th>
                    <th class="risked_type_curve">Risked Type Curve</th>
                    <th class="actual_boe">Actual</th>
                    <th class="actual_oil" style="display:none;">Actual</th>
                    <th class="actual_ngl" style="display:none;">Actual</th>
                    <th class="actual_gas" style="display:none;">Actual</th>
                    <th class="proposed_profile">Proposed Profile</th>
                    <th class="manual_boe">Manual Override</th>
                    <th class="manual_oil" style="display:none;">Manual Override</th>
                    <th class="manual_ngl" style="display:none;">Manual Override</th>
                    <th class="manual_gas" style="display:none;">Manual Override</th>
                    <th class="used_profile">Used Profile</th>
                    <th class="SFID">SFID</th>
                </tr>
            </thead>
            <tbody>
            <apex:repeat var="prodMonth" value="{!productionByMonth}">
                <tr>
                    <td class="month">{!prodMonth.month}</td>
                    <td class="cal_month">
                        <apex:outputText value="{0,date,MMM-yy}">
                            <apex:param value="{!prodMonth.calMonth}" />
                        </apex:outputText>
                    </td>
                    <td class="type_curve_boe">{!prodMonth.typeCurveBOE}</td>
                    <td class="type_curve_oil" style="display:none;">{!prodMonth.typeCurveOil}</td>
                    <td class="type_curve_ngl" style="display:none;">{!prodMonth.typeCurveNGL}</td>
                    <td class="type_curve_gas" style="display:none;">{!prodMonth.typeCurveGas}</td>
                    <td class="risked_type_curve"></td>
                    <td class="actual_boe">{!prodMonth.actualBOE}</td>
                    <td class="actual_oil" style="display:none;">{!prodMonth.actualOil}</td>
                    <td class="actual_ngl" style="display:none;">{!prodMonth.actualNGL}</td>
                    <td class="actual_gas" style="display:none;">{!prodMonth.actualGas}</td>
                    <td class="proposed_profile"></td>
                    <td class="manual_boe">{!prodMonth.manualBOE}</td>
                    <td class="manual_oil" style="display:none;">{!prodMonth.manualOil}</td>
                    <td class="manual_ngl" style="display:none;">{!prodMonth.manualNGL}</td>
                    <td class="manual_gas" style="display:none;">{!prodMonth.manualGas}</td>
                    <td class="used_profile"></td>
                    <td class="SFID">{!prodMonth.sfid}</td>
                </tr>
            </apex:repeat> 
            </tbody>
        </table>
    </apex:outputPanel>
</apex:page>